package stockMarketApplet.GUI;

import java.awt.*;
import java.applet.*;

// DataCanvas is a class, that prints out 4 values:
// depth, size, time and fitness. These values have to be set
// externally by the Applet that created an instance of DataCanvas.
public class DataCanvas extends Canvas {
  private final static int ROWS = 5;
  private final static int COLS = 2;
  private String title;
  private Rectangle inb;
  private Font smallfont;
  private FontMetrics metric;
  private int fheight;
  private int width;
  private int height;
  private int depth;
  private int size;
  private long time;
  private double fitness;
  // Create Display for four changeabe values with fixed names
  public DataCanvas()
  {
    super();
    smallfont= new Font("Courier", Font.PLAIN, 12);
    setFont(smallfont);
    metric= this.getFontMetrics(smallfont);
    fheight= metric.getHeight();
    depth = 0;
    size = 0;
    time = -1;
    fitness = 0.0;
  }
  // Set the four values of depth, size, time and fitness
  public void setValues(int d, int s, long t, double f)
  {
    depth= d;
    size= s;
    time= t;
    fitness= f;
    repaint();
  }
  // Reset the values
  public void clear()
  {
    depth= 0;
    size= 0;
    time= -1;
    fitness= 0.0;
    repaint();
  }
  // Print the stored values into the provided graphics context
  public void paint(Graphics g)
  {
    // Construct a Rectangle that holds the space we can draw in
    Rectangle big= getBounds();
    Rectangle inb= new Rectangle(3, fheight, big.width -3, big.height - 3 );
    width = inb.width / COLS;
    height = inb.height / ROWS;
    g.drawString("Individual Data", inb.x + 0 * width, inb.y + 0 * height);
    g.drawString("Depth",     inb.x + 0 * width, inb.y + 1 * height);
    g.drawString("Size",      inb.x + 0 * width, inb.y + 2 * height);
//    g.drawString("Time",      inb.x + 0 * width, inb.y + 3 * height);
    g.drawString("Fitness",   inb.x + 0 * width, inb.y + 4 * height);
    g.drawString("" + depth,         inb.x + 1 * width, inb.y + 1 * height);
    g.drawString("" + size,          inb.x + 1 * width, inb.y + 2 * height);
    if(time == -1)
    {
//      g.drawString(" n./a. ",  inb.x + 1 * width, inb.y + 3 * height);
      g.drawString(" n./a. ",  inb.x + 1 * width, inb.y + 4 * height);
    } else
    {
//      g.drawString("" + time + " ms",  inb.x + 1 * width, inb.y + 3 * height);
      g.drawString("" + fitness,       inb.x + 1 * width, inb.y + 4 * height);
    }
  }
}
