package stockMarketApplet.GUI;

import java.awt.*;
import java.util.*;
import java.applet.*;
import javax.swing.*;
import java.awt.event.*;

import stockMarketApplet.GUI.*;
import stockMarketApplet.util.*;
import stockMarketApplet.market.*;
import stockMarketApplet.market.io.*;


// This class opens a window with several scrollbars and an optional List.
// When the OK button is pressed, the changed values are directly set in
// the assigned Market
public class OptTechnicalFrame extends Frame {
  private static final byte TOURNAMENT_SELECTION = 0;
  private static final byte PROPORTIONATE_SELECTION = 1;
  private static final byte DEPTH_CODE_GROWTH_CONTROL = 0;
  private static final byte TARPEIAN_CODE_GROWTH_CONTROL = 1;
  private final int FIXED=0;
  private final int REDQUEEN=1;
  private final byte RATE_CORRECTNESS = 0;
  private final byte STRATEGYS_RETURN = 1;
  private final byte DONT_GENERATE_LIMIT_ORDER_SELL = 0;
  private final byte GENERATE_LIMIT_ORDER_SELL = 1;
  private final byte DONT_GENERATE_LIMIT_ORDER_BUY = 0;
  private final byte GENERATE_LIMIT_ORDER_BUY = 1;
  private final byte NON_FUNDAMENTAL_BEHAVIOUR = 0;
  private final byte FUNDAMENTAL_BEHAVIOUR = 1;
  private GridBagLayout gridbag;
  private JPanel lpanel, retrainpanel, limitOrderGenPanel, cpanel, c1panel, c2panel, c3panel, rpanel, buttonpanel, selectionpanel, fitnesspanel, fundpanel, codegrowthpanel;
  int groupNumber, nTarpeian;

  private Scroller nttscroller;
  private Scroller cscroller;
  private Scroller sscroller;
  private Scroller daysscroller;
  private Scroller mlscroller;
  private Scroller popscroller;
  private Scroller genscroller;
  private Scroller parscroller;
  private Scroller maxdscroller;
//  private Scroller pcdscroller;
  private Scroller pmscroller;
  private Scroller ftscroller;
  private Scroller itdscroller;
  private Scroller mtdscroller;
  private Scroller frwscroller;
  private Scroller tsscroller;
  private Scroller psbscroller;

  private TexFld rateReturnFld;
  private TexFld maxStepLabel;
  private TexFld nTarpeianlabel;

  private JCheckBox indMV_12ChkBox;
  private JCheckBox indMV_50ChkBox;
  private JCheckBox indTRB_5ChkBox;
  private JCheckBox indTRB_50ChkBox;
  private JCheckBox indFILTER_5ChkBox;
  private JCheckBox indFILTER_63ChkBox;
  private JCheckBox indVOL_12ChkBox;
  private JCheckBox indVOL_50ChkBox;
  private JCheckBox indMOM_10ChkBox;
  private JCheckBox indMOM_60ChkBox;
  private JCheckBox indMMA_10ChkBox;
  private JCheckBox indMMA_60ChkBox;

  private JCheckBox functANDChkBox;
  private JCheckBox functORChkBox;
  private JCheckBox functNOTChkBox;
  private JCheckBox functLTChkBox;
  private JCheckBox functGTChkBox;
  private JCheckBox functEQChkBox;

  private JCheckBox limitOrderSellGenChkBox;
  private JCheckBox limitOrderBuyGenChkBox;
  private JCheckBox fundBehaviourChkBox;

  private TexFld TminFld;
  private TexFld TmaxFld;
  private TexFld TauMinFld;
  private TexFld TauMaxFld;
  private TexFld aFld;

  private Button okbutton;
  private Button cancelbutton;
  private JRadioButton redQueenRadioButton, fixedRadioButton;
  private ButtonGroup retrainningGroup = new ButtonGroup();
  private JRadioButton fitProSelRadioButton, tourSelectRadioButton;
  private ButtonGroup selectionMethodGroup = new ButtonGroup();
  private JRadioButton rateCorrectRadioButton, stratReturnRadioButton;
  private JRadioButton depthCodeGrowthControlRadioButton, tarpeianCodeGrowthControlRadioButton;
  private ButtonGroup codeGrowthControlMethodGroup = new ButtonGroup();
  private ButtonGroup fitnessFunctionGroup = new ButtonGroup();
  private Market market;
  private OptGroupNumFrame frame;

  private GPParametersRecord  gpParamRec;
  private GroupParametersRecord  groupParamRec;
  private IndicatorsRecord indicatorsRec;
  private FunctionsRecord logicFunctRec;
  private FunctionsRecord relFunctRec;

  // Create an instance of OptTechnical Frame, using the provided String as title, the Market object
  // as reference to the market whose value are to be changed and a reference to the parent Applet
  public OptTechnicalFrame(String title, Market market, OptGroupNumFrame frame, String groupNum)
  {
    super(title);
    this.setBackground(Color.lightGray);
    this.market = market;
    this.frame = frame;
    this.groupNumber = new Integer(groupNum).intValue();
    gridbag= new GridBagLayout();
    setLayout(gridbag);
    Util util = new Util();
    lpanel = new JPanel();
    lpanel.setLayout(gridbag);
    lpanel.setBackground(Color.lightGray);
    lpanel.setBorder(BorderFactory.createTitledBorder("Group Parameters"));

    retrainpanel = new JPanel();
    retrainpanel.setLayout(gridbag);
    retrainpanel.setBackground(Color.lightGray);
    retrainpanel.setBorder(BorderFactory.createTitledBorder("Retrainning conditions"));

    fitnesspanel = new JPanel();
    fitnesspanel.setLayout(gridbag);
    fitnesspanel.setBackground(Color.lightGray);
    fitnesspanel.setBorder(BorderFactory.createTitledBorder("Fitness Function"));

    limitOrderGenPanel = new JPanel();
    limitOrderGenPanel.setLayout(gridbag);
    limitOrderGenPanel.setBackground(Color.lightGray);
    limitOrderGenPanel.setBorder(BorderFactory.createTitledBorder("Limit Order Generation"));

    fundpanel = new JPanel();
    fundpanel.setLayout(gridbag);
    fundpanel.setBackground(Color.lightGray);
    fundpanel.setBorder(BorderFactory.createTitledBorder("Fundamental Behaviour"));

    cpanel = new JPanel();
    cpanel.setLayout(gridbag);
    cpanel.setBackground(Color.lightGray);

    c1panel = new JPanel();
    c1panel.setLayout(gridbag);
    c1panel.setBackground(Color.lightGray);
    c1panel.setBorder(BorderFactory.createTitledBorder("Indicators"));

    c2panel = new JPanel();
    c2panel.setLayout(gridbag);
    c2panel.setBackground(Color.lightGray);
    c2panel.setBorder(BorderFactory.createTitledBorder("Logical Functions"));

    c3panel = new JPanel();
    c3panel.setLayout(gridbag);
    c3panel.setBackground(Color.lightGray);
    c3panel.setBorder(BorderFactory.createTitledBorder("Relational Functions"));

    rpanel = new JPanel();
    rpanel.setLayout(gridbag);
    rpanel.setBackground(Color.lightGray);
    rpanel.setBorder(BorderFactory.createTitledBorder("Genetic Programming Parameters"));

    buttonpanel= new JPanel();
    buttonpanel.setLayout(gridbag);
    buttonpanel.setBackground(Color.lightGray);
    GridBagConstraints c = new GridBagConstraints();

    selectionpanel = new JPanel();
    selectionpanel.setLayout(gridbag);
    selectionpanel.setBackground(Color.lightGray);
    selectionpanel.setBorder(BorderFactory.createTitledBorder("Selection Method"));

    codegrowthpanel = new JPanel();
    codegrowthpanel.setLayout(gridbag);
    codegrowthpanel.setBackground(Color.lightGray);
    codegrowthpanel.setBorder(BorderFactory.createTitledBorder("Code Growth Control Method"));

    this.readParameters(groupNumber);

    nttscroller = new Scroller("Number traders is this group", 1, 110, groupParamRec.getNumTraders());
    util.constraints(lpanel, nttscroller, c, 0, 0, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 1, 1);
    rateReturnFld = new TexFld ("Desired rate of return",""+groupParamRec.getRate(),5);
    util.constraints(lpanel, rateReturnFld, c, 0, 2, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 1, 1);
    daysscroller = new Scroller ("Numbre of days",1,110,groupParamRec.getDays());
    util.constraints(lpanel, daysscroller, c, 0, 1, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 1, 1);
    cscroller = new Scroller ("Initial cash endowment",1,100010, (int) groupParamRec.getCash());
    util.constraints(lpanel, cscroller, c, 0, 3, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 1, 1);
    sscroller = new Scroller ("Initial endowment of shares",1,1010, (int) groupParamRec.getNumberShares());
    util.constraints(lpanel, sscroller, c, 0, 4, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 1, 1);
    mlscroller = new Scroller("Trader's memory lenght", 1, 1010, groupParamRec.getMemoryLenght());
    util.constraints(lpanel, mlscroller, c, 0, 5, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 1, 1);

    fixedRadioButton = new JRadioButton("Fixed period retrainning");
    fixedRadioButton.setBackground(Color.lightGray);
    fixedRadioButton.setMnemonic(KeyEvent.VK_F);
    fixedRadioButton.setActionCommand("Fixed period retrainning");
    fixedRadioButton.setSelected(this.groupParamRec.getRetrainningCondition()==FIXED);
    redQueenRadioButton = new JRadioButton("Red Queen retrainning");
    redQueenRadioButton.setBackground(Color.lightGray);
    redQueenRadioButton.setMnemonic(KeyEvent.VK_Q);
    redQueenRadioButton.setActionCommand("Red Queen retrainning");
    redQueenRadioButton.setSelected(this.groupParamRec.getRetrainningCondition()==REDQUEEN);
    retrainningGroup.add(redQueenRadioButton);
    retrainningGroup.add(fixedRadioButton);
    util.constraints(retrainpanel, redQueenRadioButton, c, 0, 1, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 1, 1);
    util.constraints(retrainpanel, fixedRadioButton, c, 0, 2, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 1, 1);
    frwscroller = new Scroller("Fixed retrainning periodicity",1,10510,groupParamRec.getFixedRetrainningPeriodicity());
    util.constraints(retrainpanel, frwscroller, c, 0, 3, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 1, 1);
    util.constraints(lpanel, retrainpanel, c, 0, 6, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 1, 1);

    rateCorrectRadioButton = new JRadioButton("Rate of Correctness fitness function");
    rateCorrectRadioButton.setBackground(Color.lightGray);
    rateCorrectRadioButton.setMnemonic(KeyEvent.VK_C);
    rateCorrectRadioButton.setActionCommand("Rate of Correctness fitness function");
    rateCorrectRadioButton.setSelected(this.groupParamRec.getFitnessFunctionType()==RATE_CORRECTNESS);
    stratReturnRadioButton = new JRadioButton("Strategy's return fitness function");
    stratReturnRadioButton.setBackground(Color.lightGray);
    stratReturnRadioButton.setMnemonic(KeyEvent.VK_S);
    stratReturnRadioButton.setActionCommand("Strategy's return fitness function");
    stratReturnRadioButton.setSelected(this.groupParamRec.getFitnessFunctionType()==STRATEGYS_RETURN);
    fitnessFunctionGroup.add(rateCorrectRadioButton);
    fitnessFunctionGroup.add(stratReturnRadioButton);
    util.constraints (fitnesspanel, rateCorrectRadioButton, c, 0, 1, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 1, 1) ;
    util.constraints (fitnesspanel, stratReturnRadioButton, c, 0, 2, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 1, 1) ;
    util.constraints(lpanel, fitnesspanel, c, 0, 7, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 1, 1);

    limitOrderSellGenChkBox = new JCheckBox("Profit Taking Limit Order");
    limitOrderSellGenChkBox.setBackground(Color.lightGray);
    limitOrderSellGenChkBox.setMnemonic(KeyEvent.VK_L);
    util.constraints(limitOrderGenPanel,limitOrderSellGenChkBox,c,0,0,GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 1, 1);
    util.constraints(lpanel,limitOrderGenPanel, c, 0, 8, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 1, 1);

    if (this.groupParamRec.getLimitOrderSellGeneration()==GENERATE_LIMIT_ORDER_SELL){
      limitOrderSellGenChkBox.setSelected(true);
    }
    else{
      limitOrderSellGenChkBox.setSelected(false);
    }

    limitOrderBuyGenChkBox = new JCheckBox("Limit Order to Buy after Selling");
    limitOrderBuyGenChkBox.setBackground(Color.lightGray);
    limitOrderBuyGenChkBox.setMnemonic(KeyEvent.VK_M);
    util.constraints(limitOrderGenPanel,limitOrderBuyGenChkBox,c,0,1,GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 1, 1);
    util.constraints(lpanel,limitOrderGenPanel, c, 0, 8, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 1, 1);

    if (this.groupParamRec.getLimitOrderBuyGeneration()==GENERATE_LIMIT_ORDER_BUY){
      limitOrderBuyGenChkBox.setSelected(true);
    }
    else{
      limitOrderBuyGenChkBox.setSelected(false);
    }

    fundBehaviourChkBox = new JCheckBox("Activation of Fundamental Behaviour");
    fundBehaviourChkBox.setBackground(Color.lightGray);
    fundBehaviourChkBox.setMnemonic(KeyEvent.VK_B);
    util.constraints(fundpanel,fundBehaviourChkBox,c,0,0,GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 1, 1);

    aFld = new TexFld ("Position's constant a",""+groupParamRec.getA(),5);
    util.constraints(fundpanel, aFld, c, 0, 1, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 1, 1);
    TminFld = new TexFld("Tmin",""+groupParamRec.getTmin(),5);
    util.constraints(fundpanel, TminFld, c, 0, 2, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 1, 1);
    TmaxFld = new TexFld("Tmax",""+groupParamRec.getTmax(),5);
    util.constraints(fundpanel, TmaxFld, c, 0, 3, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 1, 1);
    TauMinFld = new TexFld("TauMin",""+groupParamRec.getTauMin(),5);
    util.constraints(fundpanel, TauMinFld, c, 0, 4, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 1, 1);
    TauMaxFld = new TexFld("TauMax",""+groupParamRec.getTauMax(),5);
    util.constraints(fundpanel, TauMaxFld, c, 0, 5, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 1, 1);
    util.constraints(lpanel,fundpanel, c, 0, 9, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 1, 1);

    if (this.groupParamRec.getFundamentalBehaviour()==FUNDAMENTAL_BEHAVIOUR){
      fundBehaviourChkBox.setSelected(true);
    }
    else{
      fundBehaviourChkBox.setSelected(false);
    }

    indMV_12ChkBox = new JCheckBox("Moving Average 12 days");
    indMV_12ChkBox.setMnemonic(KeyEvent.VK_0);
    indMV_12ChkBox.setBackground(Color.lightGray);
    util.constraints(c1panel, indMV_12ChkBox, c, 0, 0, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 1, 1);
    indMV_50ChkBox = new JCheckBox("Moving Average 50 days");
    indMV_50ChkBox.setMnemonic(KeyEvent.VK_1);
    indMV_50ChkBox.setBackground(Color.lightGray);
    util.constraints(c1panel, indMV_50ChkBox, c, 0, 1, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 1, 1);
    indTRB_5ChkBox = new JCheckBox("Trading Breaking Rule 5 days");
    indTRB_5ChkBox.setMnemonic(KeyEvent.VK_2);
    indTRB_5ChkBox.setBackground(Color.lightGray);
    util.constraints(c1panel, indTRB_5ChkBox, c, 0, 2, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 1, 1);
    indTRB_50ChkBox = new JCheckBox("Trading Breaking Rule 50 days");
    indTRB_50ChkBox.setMnemonic(KeyEvent.VK_3);
    indTRB_50ChkBox.setBackground(Color.lightGray);
    util.constraints(c1panel, indTRB_50ChkBox, c, 0, 3, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 1, 1);
    indFILTER_5ChkBox = new JCheckBox("Filter 5 days");
    indFILTER_5ChkBox.setMnemonic(KeyEvent.VK_4);
    indFILTER_5ChkBox.setBackground(Color.lightGray);
    util.constraints(c1panel, indFILTER_5ChkBox, c, 0, 4, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 1, 1);
    indFILTER_63ChkBox = new JCheckBox("Filter 63 days");
    indFILTER_63ChkBox.setMnemonic(KeyEvent.VK_5);
    indFILTER_63ChkBox.setBackground(Color.lightGray);
    util.constraints(c1panel, indFILTER_63ChkBox, c, 0, 5, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 1, 1);
    indVOL_12ChkBox = new JCheckBox("Volatility 12 days");
    indVOL_12ChkBox.setMnemonic(KeyEvent.VK_6);
    indVOL_12ChkBox.setBackground(Color.lightGray);
    util.constraints(c1panel, indVOL_12ChkBox, c, 0, 6, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 1, 1);
    indVOL_50ChkBox = new JCheckBox("Volatility 50 days");
    indVOL_50ChkBox.setMnemonic(KeyEvent.VK_7);
    indVOL_50ChkBox.setBackground(Color.lightGray);
    util.constraints(c1panel, indVOL_50ChkBox, c, 0, 7, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 1, 1);
    indMOM_10ChkBox = new JCheckBox("Momentum 10 days");
    indMOM_10ChkBox.setMnemonic(KeyEvent.VK_M);
    indMOM_10ChkBox.setBackground(Color.lightGray);
    util.constraints(c1panel, indMOM_10ChkBox, c, 0, 8, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 1, 1);
    indMOM_60ChkBox = new JCheckBox("Momentum 60 days");
    indMOM_60ChkBox.setMnemonic(KeyEvent.VK_M);
    indMOM_60ChkBox.setBackground(Color.lightGray);
    util.constraints(c1panel, indMOM_60ChkBox, c, 0, 9, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 1, 1);
    indMMA_10ChkBox = new JCheckBox("Moving Average Momentum 10 days");
    indMMA_10ChkBox.setMnemonic(KeyEvent.VK_M);
    indMMA_10ChkBox.setBackground(Color.lightGray);
    util.constraints(c1panel, indMMA_10ChkBox, c, 0, 10, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 1, 1);
    indMMA_60ChkBox = new JCheckBox("Moving Average Momentum 60 days");
    indMMA_60ChkBox.setMnemonic(KeyEvent.VK_M);
    indMMA_60ChkBox.setBackground(Color.lightGray);
    util.constraints(c1panel, indMMA_60ChkBox, c, 0, 11, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 1, 1);

    functANDChkBox = new JCheckBox("AND Function");
    functANDChkBox.setMnemonic(KeyEvent.VK_8);
    functANDChkBox.setBackground(Color.lightGray);
    util.constraints(c2panel, functANDChkBox, c, 0, 0, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 1, 1);
    functORChkBox = new JCheckBox("OR Function");
    functORChkBox.setMnemonic(KeyEvent.VK_9);
    functORChkBox.setBackground(Color.lightGray);
    util.constraints(c2panel, functORChkBox, c, 0, 1, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 1, 1);
    functNOTChkBox = new JCheckBox("NOT Function");
    functNOTChkBox.setMnemonic(KeyEvent.VK_A);
    functNOTChkBox.setBackground(Color.lightGray);
    util.constraints(c2panel, functNOTChkBox, c, 0, 2, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 1, 1);
    functLTChkBox = new JCheckBox("Less Than Function");
    functLTChkBox.setMnemonic(KeyEvent.VK_B);
    functLTChkBox.setBackground(Color.lightGray);
    util.constraints(c3panel, functLTChkBox, c, 0, 0, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 1, 1);
    functGTChkBox = new JCheckBox("Greater Than Function");
    functGTChkBox.setMnemonic(KeyEvent.VK_C);
    functGTChkBox.setBackground(Color.lightGray);
    util.constraints(c3panel, functGTChkBox, c, 0, 1, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 1, 1);
    functEQChkBox = new JCheckBox("Equal to Function");
    functEQChkBox.setMnemonic(KeyEvent.VK_D);
    functEQChkBox.setBackground(Color.lightGray);
    util.constraints(c3panel, functEQChkBox, c, 0, 2, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 1, 1);

    for (int i=0; i<indicatorsRec.getIndicatorsNames().length ; i++){
      if(indicatorsRec.getIndicatorsNames()[i].compareTo("MV_12")==0){
        indMV_12ChkBox.setSelected(true);
      }else if(indicatorsRec.getIndicatorsNames()[i].compareTo("MV_50")==0){
        indMV_50ChkBox.setSelected(true);
      }else if (indicatorsRec.getIndicatorsNames()[i].compareTo("TRB_5")==0){
        indTRB_5ChkBox.setSelected(true);
      }else if (indicatorsRec.getIndicatorsNames()[i].compareTo("TRB_50")==0){
        indTRB_50ChkBox.setSelected(true);
      }else if (indicatorsRec.getIndicatorsNames()[i].compareTo("Filter_5")==0){
        indFILTER_5ChkBox.setSelected(true);
      }else if (indicatorsRec.getIndicatorsNames()[i].compareTo("Filter_63")==0){
        indFILTER_63ChkBox.setSelected(true);
      }else if (indicatorsRec.getIndicatorsNames()[i].compareTo("VOL_12")==0){
        indVOL_12ChkBox.setSelected(true);
      }else if (indicatorsRec.getIndicatorsNames()[i].compareTo("VOL_50")==0){
        indVOL_50ChkBox.setSelected(true);
      }else if (indicatorsRec.getIndicatorsNames()[i].compareTo("MOM_10")==0){
        indMOM_10ChkBox.setSelected(true);
      }else if (indicatorsRec.getIndicatorsNames()[i].compareTo("MOM_60")==0){
        indMOM_60ChkBox.setSelected(true);
      }else if (indicatorsRec.getIndicatorsNames()[i].compareTo("MMA_10")==0){
        indMMA_10ChkBox.setSelected(true);
      }else if (indicatorsRec.getIndicatorsNames()[i].compareTo("MMA_60")==0){
        indMMA_60ChkBox.setSelected(true);
      }
    }

    for (int i=0; i<logicFunctRec.getFunctsNames().length ; i++){
      if(logicFunctRec.getFunctsNames()[i].compareTo("AND")==0){
        functANDChkBox.setSelected(true);
      }else if(logicFunctRec.getFunctsNames()[i].compareTo("OR")==0){
        functORChkBox.setSelected(true);
      }else if (logicFunctRec.getFunctsNames()[i].compareTo("NOT")==0){
        functNOTChkBox.setSelected(true);
      }
    }

    for (int i=0; i<relFunctRec.getFunctsNames().length ; i++){
      if (relFunctRec.getFunctsNames()[i].compareTo("<")==0){
        functLTChkBox.setSelected(true);
      }else if (relFunctRec.getFunctsNames()[i].compareTo(">")==0){
        functGTChkBox.setSelected(true);
      }else if (relFunctRec.getFunctsNames()[i].compareTo("=")==0){
        functEQChkBox.setSelected(true);
      }
    }

    util.constraints (cpanel, c1panel, c, 0, 0, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 1, 1);
    util.constraints (cpanel, c2panel, c, 0, 1, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 1, 1);
    util.constraints (cpanel, c3panel, c, 0, 2, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 1, 1);

    itdscroller = new Scroller ("Initial Tree Depth",1,50,gpParamRec.getIniTreeDepth());
    util.constraints(rpanel, itdscroller, c, 0, 0, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 1, 1);
    parscroller = new Scroller("% Parents to copy", 0, 110, gpParamRec.getPercentCopy());
    util.constraints(rpanel, parscroller, c, 0, 1, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 1, 1);
    pmscroller = new Scroller("% Mutation", 0, 110, (int) (gpParamRec.getProbMutation()));
    util.constraints(rpanel, pmscroller, c, 0, 2, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 1, 1);
    genscroller = new Scroller("Number of generations  ", 1, 510, gpParamRec.getMaxGenerations());
    util.constraints(rpanel, genscroller, c, 0, 4, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 1, 1);
    popscroller = new Scroller("Population size", 1, 1010, gpParamRec.getPopulationSize());
    util.constraints(rpanel, popscroller, c, 0, 5, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 1, 1);
    pmscroller = new Scroller("% Maximization", 0, 110, (int) (gpParamRec.getProbMaximization()));
    util.constraints(rpanel, pmscroller, c, 0, 6, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 1, 1);
    maxStepLabel = new TexFld ("Maximization Step",""+gpParamRec.getMaximizationStep(),7);
    util.constraints(rpanel, maxStepLabel, c, 0, 7, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 1, 1);

    fitProSelRadioButton = new JRadioButton("Fitness Proportionate Selection");
    fitProSelRadioButton.setBackground(Color.lightGray);
    fitProSelRadioButton.setMnemonic(KeyEvent.VK_F);
    fitProSelRadioButton.setActionCommand("Fitness Proportionate Selection");
    fitProSelRadioButton.setSelected(this.gpParamRec.getSelectionMethod() == PROPORTIONATE_SELECTION);
    tourSelectRadioButton = new JRadioButton("Tournament Selection");
    tourSelectRadioButton.setBackground(Color.lightGray);
    tourSelectRadioButton.setMnemonic(KeyEvent.VK_R);
    tourSelectRadioButton.setActionCommand("Tournament Selection");
    tourSelectRadioButton.setSelected(this.gpParamRec.getSelectionMethod() == TOURNAMENT_SELECTION);
    selectionMethodGroup.add(fitProSelRadioButton);
    selectionMethodGroup.add(tourSelectRadioButton);
    util.constraints(selectionpanel, fitProSelRadioButton, c, 0, 1, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 1, 1);
    util.constraints(selectionpanel, tourSelectRadioButton, c, 0, 2, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 1, 1);
    tsscroller = new Scroller("Tournament Selection Size",1,510,gpParamRec.getTournamentSize());
    psbscroller = new Scroller("Probability of Selecting the Best",1,110,gpParamRec.getProbSelectBest());
    util.constraints(selectionpanel, tsscroller, c, 0, 2, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 1, 1);
    util.constraints(selectionpanel, psbscroller, c, 0, 3, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 1, 1);
    util.constraints(rpanel, selectionpanel, c, 0, 8, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 1, 1);

    depthCodeGrowthControlRadioButton = new JRadioButton("Depth code growth method");
    depthCodeGrowthControlRadioButton.setBackground(Color.lightGray);
    depthCodeGrowthControlRadioButton.setSelected(this.gpParamRec.getCodeGrowthControlMethod() == DEPTH_CODE_GROWTH_CONTROL);
    tarpeianCodeGrowthControlRadioButton = new JRadioButton("Tarpeian code growth method");
    tarpeianCodeGrowthControlRadioButton.setBackground(Color.lightGray);
    tarpeianCodeGrowthControlRadioButton.setSelected(this.gpParamRec.getCodeGrowthControlMethod() == TARPEIAN_CODE_GROWTH_CONTROL);
    util.constraints(codegrowthpanel, depthCodeGrowthControlRadioButton, c, 0, 1, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 1, 1);
    util.constraints(codegrowthpanel, tarpeianCodeGrowthControlRadioButton, c, 0, 2, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 1, 1);
    codeGrowthControlMethodGroup.add(depthCodeGrowthControlRadioButton);
    mtdscroller = new Scroller ("Maximum Tree Depth",1,50,gpParamRec.getMaxTreeDepth());
    util.constraints(codegrowthpanel, mtdscroller, c, 0, 3, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 1, 1);
    codeGrowthControlMethodGroup.add(tarpeianCodeGrowthControlRadioButton);
    nTarpeianlabel = new TexFld("Tarpeian method's parameter n",""+gpParamRec.getNTarpeian(),7);
    util.constraints(codegrowthpanel, nTarpeianlabel, c, 0, 4, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 1, 1);
    util.constraints(rpanel, codegrowthpanel, c, 0, 9, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 1, 1);

    util.constrain(buttonpanel, okbutton= new Button("Ok"), 1, 0, 1, 1, 5, 10, 0, 0);
    util.constrain(buttonpanel, cancelbutton= new Button("Cancel"), 2, 0, 1, 1, 5, 10, 0, 0);

    util.constrain(this, new Label("Technical Traders Parameters Group "+ groupNum), 0, 0, 5, 1,
	      GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 1.0, 0.0, 0, 300, 0, 300);
    util.constrain(this, lpanel, 0, 1, 1, 1,
	      GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 1.0, 0.0, 0, 0, 0, 0);
    util.constrain(this, cpanel, 1, 1, 1, 1,
	      GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 1.0, 0.0, 0, 0, 0, 0);
    util.constrain(this, rpanel, 2, 1, 1, 1,
	      GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 1.0, 0.0, 0, 0, 0, 0);
    util.constrain(this, buttonpanel, 0, 2, 3, 1,
	      GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 1.0, 1.0, 0, 0, 0, 0);
    pack();
  }

  // Handle input events
  public boolean action(Event e, Object arg)
  {
    if(e.target == okbutton)
    {
      saveParameters(groupNumber);
      this.dispose();
      try{
        this.finalize();
      }catch (Throwable ee)
      {
        System.out.println("Throw exeption ");
      }
      return true;
    } else if(e.target == cancelbutton)
    {
      this.dispose();
      try{
        this.finalize();
      }catch (Throwable ee )
      {
        System.out.println("Throw exeption ");
      }
      return true;
    } else
    return false;
  }

  private void readParameters(int groupNumb){
    this.readGPParameters(groupNumb);
    this.readGroupParameters(groupNumb);
    this.readIndicators(groupNumb);
    this.readLogicalFunctions(groupNumb);
    this.readRelationalFunctions(groupNumb);
  }

  private void saveParameters(int groupNumb){
    this.saveGPParameters(groupNumb);
    this.saveGroupParameters(groupNumb);
    this.saveIndicators(groupNumb);
    this.saveLogicalFunctions(groupNumb);
    this.saveRelationalFunctions(groupNumb);
  };

  private void readGPParameters(int groupNum){
    gpParamRec = new GPParametersRecord();
    InputGPParameters inputGPParam = new InputGPParameters();
    gpParamRec = inputGPParam.readParameters(groupNum);
  }

  private void saveGPParameters(int groupNum){
    gpParamRec.setIniTreeDepth((byte)(itdscroller.getValue()));
    gpParamRec.setMaxTreeDepth((byte)(mtdscroller.getValue()));
    gpParamRec.setPercentCopy((byte)parscroller.getValue());
    gpParamRec.setProbMutation((byte)(pmscroller.getValue()));
//    gpParamRec.setProbCrossover((byte)(pcdscroller.getValue()));
    gpParamRec.setMaxGenerations(genscroller.getValue());
    gpParamRec.setPopulationSize(popscroller.getValue());
    gpParamRec.setProbMaximization((byte)(pmscroller.getValue()));
    gpParamRec.setMaximizationStep(new Double(maxStepLabel.getValue()).doubleValue());
    if (tourSelectRadioButton.isSelected()){
      gpParamRec.setSelectionMethod(TOURNAMENT_SELECTION);
      gpParamRec.setTournamentSize(tsscroller.getValue());
      gpParamRec.setProbSelectBest((byte)psbscroller.getValue());
    }
    else{
      gpParamRec.setSelectionMethod(PROPORTIONATE_SELECTION);
    }

    if (tarpeianCodeGrowthControlRadioButton.isSelected()){
      gpParamRec.setCodeGrowthControlMethod(TARPEIAN_CODE_GROWTH_CONTROL);
      gpParamRec.setNTarpeian(new Integer(nTarpeianlabel.getValue()).intValue() );
    }
    else
    {
      gpParamRec.setCodeGrowthControlMethod(DEPTH_CODE_GROWTH_CONTROL);
      gpParamRec.setNTarpeian(new Integer(mtdscroller.getValue()).intValue() );
    }
    OutputGPParameters outputGPParam = new OutputGPParameters();
    outputGPParam.saveParameters(gpParamRec, groupNum);
  }

  private void readGroupParameters(int groupNum){
    groupParamRec = new GroupParametersRecord();
    InputGroupParameters inputGroupParam = new InputGroupParameters();
    groupParamRec = inputGroupParam.readGroupParameters(groupNum);
  }

  private void saveGroupParameters(int groupNum){
    groupParamRec.setNumTraders(nttscroller.getValue());
    groupParamRec.setDays(daysscroller.getValue());
    groupParamRec.setRate(new Double(rateReturnFld.getValue()).doubleValue());
    groupParamRec.setCash(cscroller.getValue());
    groupParamRec.setNumberShares(sscroller.getValue());
    groupParamRec.setMemoryLenght(mlscroller.getValue());
    if(fixedRadioButton.isSelected())
      groupParamRec.setRetrainningCondition(FIXED);
    else
      groupParamRec.setRetrainningCondition(REDQUEEN);
    groupParamRec.setFixedRetrainningPeriodicity(frwscroller.getValue());
    if (rateCorrectRadioButton.isSelected())
      groupParamRec.setFitnessFunctionType(RATE_CORRECTNESS);
    else
      groupParamRec.setFitnessFunctionType(STRATEGYS_RETURN);
    if (limitOrderSellGenChkBox.isSelected()){
      groupParamRec.setLimitOrderSellGeneration(GENERATE_LIMIT_ORDER_SELL);
    }
    else{
      groupParamRec.setLimitOrderSellGeneration(DONT_GENERATE_LIMIT_ORDER_SELL);
    }
    if (limitOrderBuyGenChkBox.isSelected()){
      groupParamRec.setLimitOrderBuyGeneration(GENERATE_LIMIT_ORDER_BUY);
    }
    else{
      groupParamRec.setLimitOrderBuyGeneration(DONT_GENERATE_LIMIT_ORDER_BUY);
    }
    if (fundBehaviourChkBox.isSelected()){
      groupParamRec.setFundamentalBehaviour(FUNDAMENTAL_BEHAVIOUR);
    }
    else{
      groupParamRec.setFundamentalBehaviour(NON_FUNDAMENTAL_BEHAVIOUR);
    }
    groupParamRec.setTmin(new Double(TminFld.getValue()).doubleValue());
    groupParamRec.setTmax(new Double(TmaxFld.getValue()).doubleValue());
    groupParamRec.setTauMin(new Double(TauMinFld.getValue()).doubleValue());
    groupParamRec.setTauMax(new Double(TauMaxFld.getValue()).doubleValue());
    groupParamRec.setA(new Double(this.aFld.getValue()).doubleValue());
    OutputGroupParameters outputGroupParam = new OutputGroupParameters();
    outputGroupParam.saveParameters(groupParamRec, groupNum);
  }

  private void readIndicators(int groupNum){
    indicatorsRec = new IndicatorsRecord();
    InputIndicators inputIndicators = new InputIndicators();
    indicatorsRec = inputIndicators.readIndicators(groupNum);
  }

  private void saveIndicators(int groupNum){
    int count = 0;
    int i = 0;
    if (indMV_12ChkBox.isSelected())
      count++;
    if (indMV_50ChkBox.isSelected())
      count++;
    if (indTRB_5ChkBox.isSelected())
      count++;
    if (indTRB_50ChkBox.isSelected())
      count++;
    if (indFILTER_5ChkBox.isSelected())
      count++;
    if (indFILTER_63ChkBox.isSelected())
      count++;
    if (indVOL_12ChkBox.isSelected())
      count++;
    if (indVOL_50ChkBox.isSelected())
      count++;
    if (indMOM_10ChkBox.isSelected())
      count++;
    if (indMOM_60ChkBox.isSelected())
      count++;
    if (indMMA_10ChkBox.isSelected())
      count++;
    if (indMMA_60ChkBox.isSelected())
      count++;

    String[] temp = new String[count];

    if (indMV_12ChkBox.isSelected()){
      temp[i] = "MV_12";
      i++;
    }
    if (indMV_50ChkBox.isSelected()){
      temp[i] = "MV_50";
      i++;
    }
    if (indTRB_5ChkBox.isSelected()){
      temp[i] = "TRB_5";
      i++;
    }
    if (indTRB_50ChkBox.isSelected()){
      temp[i] = "TRB_50";
      i++;
    }
    if (indFILTER_5ChkBox.isSelected()){
      temp[i] = "Filter_5";
      i++;
    }
    if (indFILTER_63ChkBox.isSelected()){
      temp[i] = "Filter_63";
      i++;
    }
    if (indVOL_12ChkBox.isSelected()){
      temp[i] = "VOL_12";
      i++;
    }
    if (indVOL_50ChkBox.isSelected()){
      temp[i] = "VOL_50";
      i++;
    }
    if (indMOM_10ChkBox.isSelected()){
      temp[i] = "MOM_10";
      i++;
    }
    if (indMOM_60ChkBox.isSelected()){
      temp[i] = "MOM_60";
      i++;
    }
    if (indMMA_10ChkBox.isSelected()){
      temp[i] = "MMA_10";
      i++;
    }
    if (indMMA_60ChkBox.isSelected()){
      temp[i] = "MMA_60";
      i++;
    }
//      count++;
    indicatorsRec.setIndicatorsNames(temp);
    OutputIndicators outputIndicators = new OutputIndicators();
    outputIndicators.saveParameters(indicatorsRec, groupNum);
  }

  private void readLogicalFunctions(int groupNum){
    logicFunctRec = new FunctionsRecord();
    InputFunctionsLogic inputLogicFunct = new InputFunctionsLogic();
    logicFunctRec = inputLogicFunct.readFunctions(groupNum);
  }

  private void saveLogicalFunctions(int groupNum){
    int count = 0;
    int i = 0;
    String[] temp;

    if (functANDChkBox.isSelected())
      count++;
    if (functORChkBox.isSelected())
      count++;
    if (functNOTChkBox.isSelected())
      count++;

    temp = new String[count];

    if (functANDChkBox.isSelected()){
      temp[i] = "AND";
      i++;
    }
    if (functORChkBox.isSelected()){
      temp[i] = "OR";
      i++;
    }
    if (functNOTChkBox.isSelected()){
      temp[i] = "NOT";
      i++;
    }
    logicFunctRec.setFunctsNames(temp);
    OutputFunctionsLogic outputFunctionsLogic = new OutputFunctionsLogic();
    outputFunctionsLogic.saveParameters(logicFunctRec, groupNum);
  }

  private void readRelationalFunctions(int groupNum){
    relFunctRec = new FunctionsRecord();
    InputFunctionsRel inputRelFunct = new InputFunctionsRel();
    relFunctRec = inputRelFunct.readFunctions(groupNum);
  }

  private void saveRelationalFunctions(int groupNum){
    int count = 0;
    int i = 0;
    String[] temp;

    if (functLTChkBox.isSelected())
      count++;
    if (functGTChkBox.isSelected())
      count++;
    if (functEQChkBox.isSelected())
      count++;

    temp = new String[count];

    if (functLTChkBox.isSelected()){
      temp[i] = "<";
      i++;
    }
    if (functGTChkBox.isSelected()){
      temp[i] = ">";
      i++;
    }
    if (functEQChkBox.isSelected()){
      temp[i] = "=";
      i++;
    }
    relFunctRec.setFunctsNames(temp);
    OutputFunctionsRel outputFunctionsRel = new OutputFunctionsRel();
    outputFunctionsRel.saveParameters(relFunctRec, groupNum);
  }

}