package stockMarketApplet;

import java.awt.*;
import java.util.*;
import javax.swing.*;
import java.applet.*;
import java.awt.event.*;
import stockMarketApplet.GUI.*;
import stockMarketApplet.util.*;
import stockMarketApplet.market.*;
import stockMarketApplet.market.agents.technicalTrader.basics.*;

public class StockMarketApplet extends Applet {
  protected Market market = null;
  // Labels for the buttons
  final private static String TRAIN   = "Train traders";
  final private static String TRADE   = "Start trading";
  final private static String STOP    = "Stop";
  final private static String STEP    = "Step";
  final private static String PARAM   = "Parameters";
  final private static String LOAD    = "Load traders";
  final private static String SAVE    = "Save traders";
  final private static String RESET   = "Reset";
  final private static String BEST    = "Best";
  final private static String NEXT    = "Next";
  final private static String ACTION  = "Action";
  final private static String PREV    = "Prev";
  final private static String WORST   = "Worst";

  private Vector runbuttons;
  private Button stopButton;
  private Button saveButton;
  private Button tradeButton;
  private Button bestButton;
  private Button worstButton;
  private Button nextButton;
  private Button previousButton;
  private Button resetButton;
  private Button paramButton;
  private Button trainButton;
  private Button loadButton;

  private static byte loaded = 0;
  // Panels to display information about the population and some individuals
  // Statistic Panel
  protected StatPanel statPan;
  // Text output
  protected TextField textStatus;
  // Text output
  protected TextArea areaTextl;
  // Raw fitness
  protected PlotCanvas priceCanvas;
  // Average sizes
  protected PlotCanvas wealthCanvas;
  // Individual data
  protected DataCanvas dataCanvas;
  // Canvas to draw indviduals in
  protected MiniCanvas grafixMiniCanvas;
  // Treeview of specific individuals
  protected TreePanel treePan;
  // Layout
  private GridBagLayout layouter;
  private Panel textpanel;
  private Panel graphpanel;
  private Panel buttonpanel;
  private Font smallfont;
  private Font normfont;
  // Frame for changing the parameters
  private OptFrame optframe;

  FlowLayout flowLayout1 = new FlowLayout();

  //  Component component1;
  class MiniCanvas extends Canvas {
    public void clear()
    {
      Rectangle b = getBounds();
      Graphics g = getGraphics();
      g.clearRect(0, 0, b.width, b.height);
    }
    public void paint(Graphics g)
    {
    }
  }
  //Constructor of the applet
  public StockMarketApplet() {
  }
  // Creates all user interface components
  public void init()
  {
    this.setBackground(Color.lightGray);
    Util util = new Util();
    smallfont= new Font("Courier", Font.PLAIN, 12);
    normfont= getFont();
    setFont(smallfont);
    runbuttons= new Vector();
    layouter= new GridBagLayout();
    setLayout(layouter);
    textpanel= new Panel();
    textpanel.setLayout(layouter);
    statPan = new StatPanel();
    util.constrain(textpanel, statPan, 0, 0, 1, 1, GridBagConstraints.HORIZONTAL, GridBagConstraints.NORTH,
    	      1.0, 0.0, 0, 0, 0, 0);
    graphpanel= new Panel();
    graphpanel.setLayout(layouter);
    priceCanvas = new PlotCanvas(PlotCanvas.THREE, "Stock Price & Fundamental Value");
    util.constrain(graphpanel, priceCanvas, 0, 0, 1, 1, GridBagConstraints.BOTH, GridBagConstraints.CENTER,
    	      1.0, 1.0, 2, 2, 2, 2);
    wealthCanvas= new PlotCanvas(PlotCanvas.THREE, "Individual's Wealth");
    util.constrain(graphpanel, wealthCanvas, 1, 0, 1, 1, GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      1.0, 1.0, 2, 2, 2, 2);
    dataCanvas = new DataCanvas();
    util.constrain(graphpanel, dataCanvas, 0, 1, 1, 1, GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      1.0, 1.0, 2, 2, 2, 2);
    grafixMiniCanvas= new MiniCanvas();
    treePan = new TreePanel();
    util.constrain(graphpanel, treePan, 1, 1, 0, 2, GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      .8, .0, 2, 2, 2, 2);
    setFont(normfont);
    initButtons();
    util.constrain(this, textpanel, 0, 0, 1, 1, GridBagConstraints.HORIZONTAL, GridBagConstraints.NORTH,
              0.0, 0.0, 0, 50, 0, 50);
    util.constrain(this, graphpanel, 0, 1, 1, 1, GridBagConstraints.BOTH, GridBagConstraints.CENTER,
              1.0, 1.0, 0, 0, 0, 0);
    areaTextl = new TextArea(2, 60);
    areaTextl.setEditable(false);
    util.constrain(this, areaTextl, 0, 2, 1, 1, GridBagConstraints.HORIZONTAL, GridBagConstraints.SOUTH,
              .0, .0, 0, 0, 0, 0);
    textStatus = new TextField();
    textStatus.setEditable(false);
    util.constrain(this, textStatus, 0, 3, 1, 1, GridBagConstraints.HORIZONTAL, GridBagConstraints.SOUTH,
    	      0.0, 0.0, 0, 0, 0, 0);
    util.constrain(this, buttonpanel, 0, 4, 1, 1, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER,
              .8, 0.0, 0, 0, 0, 0);
    this.validate();
    market = new Market();
    market.setParent(this);
    if(market == null)
      throw(new RuntimeException("No subclass of Market instanciated."));
  }
  // creates the buttons
  private void initButtons()
  {
    buttonpanel= new Panel();
    buttonpanel.setLayout(new GridLayout(2,4));
    buttonpanel.add(bestButton= new Button(BEST));
    runbuttons.addElement(bestButton);
    buttonpanel.add(nextButton= new Button(NEXT));
    runbuttons.addElement(nextButton);
    buttonpanel.add(worstButton= new Button(WORST));
    runbuttons.addElement(worstButton);
    buttonpanel.add(previousButton= new Button(PREV));
    runbuttons.addElement(previousButton);
    buttonpanel.add(paramButton= new Button(PARAM));
    runbuttons.addElement(paramButton);
    buttonpanel.add(trainButton= new Button(TRAIN));
    runbuttons.addElement(trainButton);
    buttonpanel.add(saveButton= new Button(SAVE));
    runbuttons.addElement(saveButton);
    buttonpanel.add(loadButton= new Button(LOAD));
    runbuttons.addElement(loadButton);
    buttonpanel.add(tradeButton= new Button(TRADE));
    runbuttons.addElement(tradeButton);
    buttonpanel.add(stopButton= new Button(STOP));
    runbuttons.addElement(stopButton);
    buttonpanel.add(resetButton= new Button(RESET));
    runbuttons.addElement(resetButton);
    initialButtonsSetting();
  }
  // Initial setting for the buttons
  protected void initialButtonsSetting(){
    Enumeration e = runbuttons.elements();
    while(e.hasMoreElements())
      ((Button) e.nextElement()).setEnabled(false);
    stopButton.setEnabled(false);
    resetButton.setEnabled(false);
    paramButton.setEnabled(true);
    trainButton.setEnabled(true);
    loadButton.setEnabled(true);
  }
  // Enable all buttons except the STOP button
  protected void enableButtons(){
    Enumeration e = runbuttons.elements();
    while(e.hasMoreElements())
      ((Button) e.nextElement()).setEnabled(true);
    stopButton.setEnabled(false);
  }
  // Disable all buttons except the STOP button
  protected void disableButtons()
  {
    Enumeration e = runbuttons.elements();
    while(e.hasMoreElements())
      ((Button) e.nextElement()).setEnabled(false);
    stopButton.setEnabled(true);
    if(optframe != null)
      optframe.setVisible(true);
  }
  // Handle the only kind of user input, the buttons
  public boolean action(Event e, Object arg)
  {
    if( ((String)e.arg).equals(TRAIN))
    {
      printStatus("Training is taking place ...");
      disableButtons();
      market.initialTraining();
      enableButtons();
    } else if( ((String)e.arg).equals(TRADE))
    {
      printStatus("Trading is taking place...");
      disableButtons();
      market.runTest();
    } else if( ((String)e.arg).equals(LOAD))
    {
      printStatus("Loading the previous training ...");
      disableButtons();
      market.loadInitialTraining();
      enableButtons();
    } else if( ((String)e.arg).equals(SAVE))
    {
      printStatus("Saving the current technical traders ...");
      disableButtons();
      market.saveInitialTraining();
      enableButtons();
    } else if( ((String)e.arg).equals(RESET))
    {
      resetAll();
      initialButtonsSetting();
    } else if( ((String)e.arg).equals(STOP))
    {
      printStatus("Completing the current execution ...");
      market.stopTest();
      enableButtons();
    } else if( ((String)e.arg).equals(PARAM))
    {
      if(optframe == null)
	optframe = new OptFrame("Financial Market Parameters", market, this);
      optframe.setVisible(true);
    } else if( ((String)e.arg).equals(BEST))
    {
      market.setSelected(Market.BEST);
      changedSelected();
    } else if( ((String)e.arg).equals(NEXT))
    {
      market.setSelected(Market.NEXT);
      changedSelected();
    } else if( ((String)e.arg).equals(PREV))
    {
      market.setSelected(Market.PREV);
      changedSelected();
    } else if( ((String)e.arg).equals(WORST))
    {
      market.setSelected(Market.WORST);
      changedSelected();
    }
    else
      return false;
    return true;
  }
  // Stop the background thread
  public void stop()
  {
    market.stopTest();
  }
  // When the background thread has been stopped, the buttons are enabled again
  public void stopped()
  {
    enableButtons();
    resetButton.setEnabled(true);
  }
  // When one generation has been evaluated and the fitness of its individuals
  // computed, this method will be called to display the results
  public void doneRun()
  {
    updateStats();
    market.drawSelectedIndividual(Market.DRAWEX, grafixMiniCanvas.getGraphics(), grafixMiniCanvas.getBounds());
    if(market.checkTerminate())
    {
      market.stopTest();
    }
    printStatus("Trading Round " + market.getTradingRound() + " complete");
    repaint();
  }

  // Gets data from the Market on the current generation and the selected
  // Trader and displays it in the various areas of the applet
  public void updateStats()
  {
    priceCanvas.addValues(market.getTradingRound(), market.getPrice(),
                          market.getFundamentalValue(),0);
/*    wealthCanvas.addValues(market.getTradingRound(), market.getBestWealth(),
		            market.getWorstWealth(), market.getAverageWealth());*/
    if (market.getNumTechnicalTraders()>0){
      statPan.setValues(market.getPopulationSize(),
        	      market.getBestWealth(), market.getWorstWealth(),
		      market.getAverageWealth(), market.getAverageSize());
      treePan.setCode(market.getSelectedCode());
      areaTextl.setText(market.getSelectedCode().toString());
      dataCanvas.setValues(market.getSelectedDepth(), market.getSelectedSize(),
        	          market.getSelectedTime(), market.getSelectedFitness());
    }
  }
  // When the user has changed the special Individual using the buttons,
  // update the display fields and draw it.
  private void changedSelected()
  {
    dataCanvas.setValues(market.getSelectedDepth(), market.getSelectedSize(),
		   market.getSelectedTime(), market.getSelectedFitness());
    market.drawSelectedIndividual(Market.DRAWEX, grafixMiniCanvas.getGraphics(), grafixMiniCanvas.getBounds());
    treePan.setCode(market.getSelectedCode());
    areaTextl.setText(market.getSelectedCode().toString());
  }
  public void printStatus(String str)
  {
    textStatus.setText(str);
  }
  public void clear()
  {
    areaTextl.setText("");
    textStatus.setText("");
    priceCanvas.clear();
    priceCanvas.setGenerations(market.getMaxTradingRounds());
    wealthCanvas.clear();
    wealthCanvas.setGenerations(market.getMaxTradingRounds());
    statPan.clear();
    dataCanvas.clear();
    treePan.clear();
  }
  // When the options have changed or the user clicked the RESET button, restart
  // the applet using the current settings
  public void resetAll()
  {
    market.init();
    clear();
    optframe = null;
  }
  public void paint(Graphics g)
  {
    market.drawSelectedIndividual(Market.BEST, grafixMiniCanvas.getGraphics(), grafixMiniCanvas.getBounds());
    treePan.repaint();
  }
  //Main method
  public static void main(String[] args) {
    StockMarketApplet applet = new StockMarketApplet();
    Frame frame;
    frame = new Frame() {
      protected void processWindowEvent(WindowEvent e) {
        super.processWindowEvent(e);
        if (e.getID() == WindowEvent.WINDOW_CLOSING) {
          System.exit(0);
        }
      }
      public synchronized void setTitle(String title) {
        super.setTitle(title);
        enableEvents(AWTEvent.WINDOW_EVENT_MASK);
      }
    };
    frame.setTitle("Artificial Financial Market Applet Frame");
    frame.add(applet, BorderLayout.CENTER);
    applet.init();
    applet.start();
    frame.setSize(1300,900);
    Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
    frame.setLocation(0, 0);
    frame.setVisible(true);
  }

}