package stockMarketApplet.market.agents;

import stockMarketApplet.market.io.*;

public class FundamentalTrader {

  private  final byte BUY  = 1;
  private  final byte SELL = -1;
  private  final byte HOLD = 0;

  private double cash;
  private double numberShares;
  private double wealth;
  private double T;
  private double tau;
  private byte decision;
  private boolean selling;
  private boolean buying;

  public FundamentalTrader( FundamentalParametersRecord fundParamRec) {
    this.cash = fundParamRec.getCash();
    this.numberShares = fundParamRec.getNumberShares();
    this.selling = false;
    this.buying = false;
    this.decision = HOLD;
  }
  public double getCash(){
    return this.cash;
  }
  public double getNumberShares(){
    return this.numberShares;
  }
  public double getWealth(){
    return this.wealth;
  }
  public double getT(){
    return this.T;
  }
  public double getTau(){
    return this.tau;
  }
  public byte getDecision(){
    return this.decision;
  }
  public boolean isSelling(){
    return this.selling;
  }
  public boolean isBuying(){
    return this.buying;
  }
  public void setCash(double cash){
    this.cash = cash;
  }
  public void setNumberShares(double numberShares){
    this.numberShares = numberShares;
  }
  public void setWealth(double wealth){
    this.wealth = wealth;
  }
  public void setT(double t){
    this.T = t;
  }
  public void setTau(double tau){
    this.tau =  tau;
  }
  public void setDecision(byte decision){
    this.decision = decision;
  }
  public void setSelling(boolean selling){
    this.selling = selling;
  }
  public void setBuying(boolean buying){
    this.buying = buying;
  }
  public byte takeDesicion(double price, double fundValue){
    byte decision=HOLD;
    if ((price-fundValue)>this.getT()){
      decision=SELL;
    }
    else if ((price-fundValue)<-this.getT()){
      decision=BUY;
    }
    return decision;
  }
  public boolean exitPosition(double price, double fundValue){
    boolean tempBool = false;
    if( (selling==true) && ((price-fundValue)<this.getTau()) ){
      selling = false;
      tempBool = true;
    }
    else if( (buying==true) && ((price-fundValue)>-this.getTau()) ){
      buying = false;
      tempBool = true;
    }
    return tempBool;
  }
  public double getDifference(){
    return (this.T-this.tau);
  }

}