package stockMarketApplet.market.io;

import java.io.*;

public class InputFundamentalParameters {
  private FileInputStream fileName;
  private FundamentalParametersRecord fundamentParamRec;

  public FundamentalParametersRecord readParameters(){
    try{
          fileName = new FileInputStream("parameters/FundamentalParameters.txt");
    } catch(FileNotFoundException e) {
          System.out.print("File Not Found");
    }
    fundamentParamRec = new FundamentalParametersRecord();
    fundamentParamRec.setCash((new Double(readLine())).doubleValue());
    fundamentParamRec.setNumberShares((new Double(readLine())).doubleValue());
    fundamentParamRec.setInitialValue((new Double(readLine())).doubleValue());
    fundamentParamRec.setMean((new Double(readLine())).doubleValue());
    fundamentParamRec.setStandardDeviation((new Double(readLine())).doubleValue());
    fundamentParamRec.setTmin((new Double(readLine())).doubleValue());
    fundamentParamRec.setTmax((new Double(readLine())).doubleValue());
    fundamentParamRec.setTauMin((new Double(readLine())).doubleValue());
    fundamentParamRec.setTauMax((new Double(readLine())).doubleValue());
    fundamentParamRec.setA((new Double(readLine())).doubleValue());
    return fundamentParamRec;
  }
  private  String readLine(){
    int c;
    int cr = 13;
    String bufferLine = new String();
    try{
        c = fileName.read();
        while (c!=cr && c!=-1) {
          bufferLine += (char)(c);
          c = fileName.read();
        }
        fileName.skip(1);
    } catch(IOException e) {
      System.out.print("IO Exception: " + e.getMessage());
    }catch(ArrayIndexOutOfBoundsException e1){
      System.out.print("Array Index Out Of Bounds Exception: " + e1.getMessage());
    }
    return bufferLine;
  }

}