package stockMarketApplet.market.io;

import java.io.*;

public class InputGPParameters {
  private  static FileInputStream fileName;
  private  static GPParametersRecord[] GPParamRec;
  private  static int c;
  private  static int cr = 13;

  public GPParametersRecord[] readGroupsGPParameters(int numberGroupsTraders){
    GPParamRec = new GPParametersRecord[numberGroupsTraders];
    String fileNameStringCommon = "parameters/GPParameters";
    String fileNameString;
    for (int i=0; i  < numberGroupsTraders;i++){
      fileNameString = fileNameStringCommon + i + ".txt";
      try{
          fileName = new FileInputStream(fileNameString);
      } catch(FileNotFoundException e) {
          System.out.print("File Not Found");
      }
      GPParamRec[i] = new GPParametersRecord();
      GPParamRec[i].setIniTreeDepth ( (new Integer( readLine() )).byteValue() );
      GPParamRec[i].setMaxTreeDepth ((new Integer( readLine() )).byteValue());
      GPParamRec[i].setPercentCopy((new Integer( readLine() )).byteValue());
      GPParamRec[i].setProbMutation((new Double( readLine() )).byteValue());
//      GPParamRec[i].setProbCrossover((new Double( readLine() )).byteValue());
      GPParamRec[i].setProbMaximization((new Double( readLine() )).byteValue());
      GPParamRec[i].setMaxGenerations((new Integer( readLine() )).intValue());
      GPParamRec[i].setPopulationSize((new Integer( readLine() )).intValue());
      GPParamRec[i].setMinThreshold((new Double( readLine() )).doubleValue());
      GPParamRec[i].setRangeThreshold((new Double( readLine() )).doubleValue());
      GPParamRec[i].setMaximizationStep((new Double( readLine() )).doubleValue());
      GPParamRec[i].setSelectionMethod((new Integer( readLine() )).byteValue());
      GPParamRec[i].setTournamentSize((new Integer( readLine() )).intValue());
      GPParamRec[i].setProbSelectBest((new Integer( readLine() )).byteValue());
      GPParamRec[i].setWRC( (new Double( readLine() )).intValue() );
      GPParamRec[i].setWRF( (new Double( readLine() )).intValue() );
      GPParamRec[i].setWRMC( (new Double( readLine() )).intValue() );
      GPParamRec[i].setCodeGrowthControlMethod((new Integer( readLine() )).byteValue());
      GPParamRec[i].setNTarpeian((new Integer( readLine() )).intValue());
      try
      {
        fileName.close();
      } catch (IOException e){
        System.out.println("Can not close the file");
      }
    }
    return GPParamRec;
  }
  public GPParametersRecord readParameters(int groupNumber){
    GPParametersRecord gPParamRec = new GPParametersRecord();
    String fileNameString = "parameters/GPParameters"+groupNumber+".txt";
    try{
    fileName = new FileInputStream(fileNameString);
    } catch(FileNotFoundException e) {
      System.out.print("File Not Found");
    }
      gPParamRec.setIniTreeDepth ( (new Integer( readLine() )).byteValue() );
      gPParamRec.setMaxTreeDepth ((new Integer( readLine() )).byteValue());
      gPParamRec.setPercentCopy((new Integer( readLine() )).byteValue());
      gPParamRec.setProbMutation((new Double( readLine() )).byteValue());
//      gPParamRec.setProbCrossover((new Double( readLine() )).byteValue());
      gPParamRec.setProbMaximization((new Double( readLine() )).byteValue());
      gPParamRec.setMaxGenerations((new Integer( readLine() )).intValue());
      gPParamRec.setPopulationSize((new Integer( readLine() )).intValue());
      gPParamRec.setMinThreshold((new Double( readLine() )).doubleValue());
      gPParamRec.setRangeThreshold((new Double( readLine() )).doubleValue());
      gPParamRec.setMaximizationStep((new Double( readLine() )).doubleValue());
      gPParamRec.setSelectionMethod((new Integer( readLine() )).byteValue());
      gPParamRec.setTournamentSize((new Integer( readLine() )).intValue());
      gPParamRec.setProbSelectBest((new Integer( readLine() )).byteValue());
      gPParamRec.setWRC((new Double( readLine() )).intValue());
      gPParamRec.setWRF((new Double( readLine() )).intValue());
      gPParamRec.setWRMC((new Double( readLine() )).intValue());
      gPParamRec.setCodeGrowthControlMethod((new Integer( readLine() )).byteValue());
      gPParamRec.setNTarpeian((new Integer( readLine() )).intValue());
    try
    {
      fileName.close();
    } catch (IOException e){
      System.out.println("Can not close the file");
    }
    return gPParamRec;
  }
  private String readLine(){
    String bufferLine = new String();
    try{
        c = fileName.read();
        while (c!=cr && c!=-1) {
          bufferLine += (char)(c);
          c = fileName.read();
        }
        fileName.skip(1);
    } catch(IOException e) {
      System.out.print("IO Exception: " + e.getMessage());
    }catch(ArrayIndexOutOfBoundsException e1){
      System.out.print("Array Index Out Of Bounds Exception: " + e1.getMessage());
    }
    return bufferLine;
  }

}