package stockMarketApplet.market.io;

import java.io.*;

public class InputMarketParameters {
  private  FileInputStream fileName;
  private  MarketParametersRecord marketParamRec = new MarketParametersRecord();

  public MarketParametersRecord readParameters(){
    try{
          fileName = new FileInputStream("parameters/MarketParameters.txt");
    } catch(FileNotFoundException e) {
          System.out.print("File Not Found");
    }
    marketParamRec.setMaxNumTradingPeriods(new Integer(readLine()).intValue());
    marketParamRec.setTradingProportion(new Integer(readLine()).intValue());
    marketParamRec.setPriceEquation(new Integer(readLine()).intValue());
    marketParamRec.setBetha1((new Double(readLine())).doubleValue());
    marketParamRec.setBetha2((new Double(readLine())).doubleValue());
    marketParamRec.setMarketDepth((new Double(readLine())).doubleValue());
    marketParamRec.setSeed((new Long(readLine())).longValue());
    marketParamRec.setDelay((new Integer(readLine())).intValue());
    marketParamRec.setSavingFrequency((new Integer(readLine())).intValue());
    return marketParamRec;
  }
  private  String readLine(){
    int c;
    int cr = 13;
    String bufferLine = new String();
    try{
        c = fileName.read();
        while (c!=cr && c!=-1) {
          bufferLine += (char)(c);
          c = fileName.read();
        }
        fileName.skip(1);
    } catch(IOException e) {
      System.out.print("IO Exception: " + e.getMessage());
    }catch(ArrayIndexOutOfBoundsException e1){
      System.out.print("Array Index Out Of Bounds Exception: " + e1.getMessage());
    }
    return bufferLine;
  }

}