package stockMarketApplet.market.io;

import java.io.*;
import java.awt.Event;
import stockMarketApplet.market.*;
import stockMarketApplet.market.agents.NoisyTrader;
import stockMarketApplet.market.agents.technicalTrader.TechnicalTrader;
import stockMarketApplet.market.agents.FundamentalTrader;

public class OutputData {
  private static final int MV_12_Window       = 12;
  private static final int MV_50_Window       = 50;
  private static final int TRB_5_Window       = 5;
  private static final int TRB_50_Window      = 50;
  private static final int Filter_5_Window    = 5;
  private static final int Filter_63_Window   = 63;
  private static final int VOL_12_Window      = 12;
  private static final int VOL_50_Window      = 50;

  private FileOutputStream fileName;
  private DataRecord[] dataRecords;
  private TradingRecord[] tradingRecords;

  public OutputData(){
  }
  public void downLoadData (String dirName, DataRecord[] serie, int epoch){
    this.dataRecords = serie;
    String lineBuffer = new String();
    String comma = new String(",");
    byte enter = Event.ENTER;
    String iString = new String();
    iString+=epoch;
    try{
      fileName = new FileOutputStream(dirName+"/OutputData"+iString+".csv");
    }catch(FileNotFoundException e1){
      System.out.print("File Not Found Exception: " + e1.getMessage());
    }
    try{
      lineBuffer = "DATE,PRICE,MV_12,MV_50,FILTER_5,FILTER_63,TRB_5,TRB_50,VOL_12,VOL_50,MOM_10,MOM_60,MMA_10,MMA_60";
      fileName.write(lineBuffer.getBytes());
      fileName.write(enter);
      lineBuffer = new String();
      for(int i = Filter_63_Window; i < epoch+Filter_63_Window ; i++){
        lineBuffer += serie[i].getDate().toString();
        lineBuffer += comma;
        lineBuffer += serie[i].getObservation();
        lineBuffer += comma;
        lineBuffer += serie[i].getMV_12();
        lineBuffer += comma;
        lineBuffer += serie[i].getMV_50();
        lineBuffer += comma;
        lineBuffer += serie[i].getFilter_5();
        lineBuffer += comma;
        lineBuffer += serie[i].getFilter_63();
        lineBuffer += comma;
        lineBuffer += serie[i].getTRB_5();
        lineBuffer += comma;
        lineBuffer += serie[i].getTRB_50();
        lineBuffer += comma;
        lineBuffer += serie[i].getVOL_12();
        lineBuffer += comma;
        lineBuffer += serie[i].getVOL_50();
        lineBuffer += comma;
        lineBuffer += serie[i].getMOM_10();
        lineBuffer += comma;
        lineBuffer += serie[i].getMOM_60();
        lineBuffer += comma;
        lineBuffer += serie[i].getMMA_10();
        lineBuffer += comma;
        lineBuffer += serie[i].getMMA_60();
        fileName.write(lineBuffer.getBytes());
        fileName.write(enter);
        lineBuffer = new String();
      }
    } catch(IOException e) {
      System.out.print("IO Exception: " + e.getMessage());
    }catch(ArrayIndexOutOfBoundsException e1){
      System.out.print("Array Index Out Of Bounds Exception: " + e1.getMessage());
    }
    try{
      fileName.close();
    }catch(IOException e){
      System.out.print("IO Exception: " + e.getMessage());
    }
  }
  public void downLoadData (String dirName, TradingRecord[] serie, int epoch){
    this.tradingRecords = serie;
    String lineBuffer = new String();
    String comma = new String(",");
    byte enter = Event.ENTER;
    String iString = new String();
    iString+=epoch;
    try{
      fileName = new FileOutputStream(dirName+"/OutputTrading"+iString+".csv");
    }catch(FileNotFoundException e1){
      System.out.print("File Not Found Exception: " + e1.getMessage());
    }
    try{
      lineBuffer = "EPOCH,BIDS,OFFERS,PRICE,FundamentalValue,TOTAL WEALTH,AVG WEALTH,TotalCash,TotalShares,NumRetrainedTraders,NumSellers,NumBuyers,NumHolders";
      fileName.write(lineBuffer.getBytes());
      fileName.write(enter);
      lineBuffer = new String();
      for(int i = Filter_63_Window; i < epoch+Filter_63_Window ; i++){
        lineBuffer += serie[i].getEpoch();
        lineBuffer += comma;
        lineBuffer += serie[i].getBids();
        lineBuffer += comma;
        lineBuffer += serie[i].getOffers();
        lineBuffer += comma;
        lineBuffer += serie[i].getPrice();
        lineBuffer += comma;
        lineBuffer += serie[i].getFundamentalValue();
        lineBuffer += comma;
        lineBuffer += serie[i].getTotalWealth();
        lineBuffer += comma;
        lineBuffer += serie[i].getAverageWealth();
        lineBuffer += comma;
        lineBuffer += serie[i].getTotalCash();
        lineBuffer += comma;
        lineBuffer += serie[i].getTotalShares();
        lineBuffer += comma;
        lineBuffer += serie[i].getnumRetrainTraders();
        lineBuffer += comma;
        lineBuffer += serie[i].getNumSellers();
        lineBuffer += comma;
        lineBuffer += serie[i].getNumBuyers();
        lineBuffer += comma;
        lineBuffer += serie[i].getNumHolders();
        fileName.write(lineBuffer.getBytes());
        fileName.write(enter);
        lineBuffer = new String();
      }
    } catch(IOException e) {
      System.out.print("IO Exception: " + e.getMessage());
    }catch(ArrayIndexOutOfBoundsException e1){
      System.out.print("Array Index Out Of Bounds Exception: " + e1.getMessage());
    }
    try{
      fileName.close();
    }catch(IOException e){
      System.out.print("IO Exception: " + e.getMessage());
    }
  }
  public void downLoadData (String dirName, TechnicalTrader[] serie, FileOutputStream fileName){
    String lineBuffer = new String();
    String comma = new String(",");
    byte enter = Event.ENTER;
    try{
/*                                    ,PROCEEDSCASH,BOUGHTSTOCKS,         CUMULATIVERC,CUMULATIVERF,CUMULATIVECASH,CUMULATIVESTOCKS,CUMULATIVERMC,CUMULATIVEPROCEEDSCASH,CUMULATIVEBOUGHTSTOCKS*/
      lineBuffer = "TRADER,CASH,STOCKS,WEALTH,RC,RF,RMC,RETRAINS,RETRAINED,DECISION";
      fileName.write(lineBuffer.getBytes());
      fileName.write(enter);
      lineBuffer = new String();
       for(int i = 0; i < serie.length ; i++){
        lineBuffer += i+1;
        lineBuffer += comma;
        lineBuffer += serie[i].getCash();
        lineBuffer += comma;
        lineBuffer += serie[i].getStocks();
        lineBuffer += comma;
        lineBuffer += serie[i].getWealth();
        lineBuffer += comma;
        lineBuffer += serie[i].getRC();
        lineBuffer += comma;
        lineBuffer += serie[i].getRF();
        lineBuffer += comma;
        lineBuffer += serie[i].getRMC();
        lineBuffer += comma;
        lineBuffer += serie[i].getNumRetrains();
        lineBuffer += comma;
        lineBuffer += serie[i].getRetrain();
//        lineBuffer += comma;
//        lineBuffer += serie[i].getCumulativeRC();
//        lineBuffer += comma;
//        lineBuffer += serie[i].getCumulativeRF();
//        lineBuffer += comma;
//        lineBuffer += serie[i].getCumulativeRMC();
//        lineBuffer += comma;
//        lineBuffer += serie[i].getCumulativeCash();
//        lineBuffer += comma;
//        lineBuffer += serie[i].getCumulativeStocks();
        lineBuffer += comma;
        lineBuffer += serie[i].getDecision();
        fileName.write(lineBuffer.getBytes());
        fileName.write(enter);
        lineBuffer = new String();
      }
    } catch(IOException e) {
      System.out.print("IO Exception: " + e.getMessage());
    }catch(ArrayIndexOutOfBoundsException e1){
      System.out.print("Array Index Out Of Bounds Exception: " + e1.getMessage());
    }
  }

  public void downLoadData (String dirName, NoisyTrader[] serie, FileOutputStream fileName){
    String lineBuffer = new String();
    String comma = new String(",");
    byte enter = Event.ENTER;
    try{
      lineBuffer = "TRADER,CASH,STOCKS,DECISION";
      fileName.write(lineBuffer.getBytes());
      fileName.write(enter);
      lineBuffer = new String();
       for(int i = 0; i < serie.length ; i++){
        lineBuffer += i+1;
        lineBuffer += comma;
        lineBuffer += serie[i].getCash();
        lineBuffer += comma;
        lineBuffer += serie[i].getNumberShares();
        lineBuffer += comma;
        lineBuffer += serie[i].getDecision();
        fileName.write(lineBuffer.getBytes());
        fileName.write(enter);
        lineBuffer = new String();
      }
    } catch(IOException e) {
      System.out.print("IO Exception: " + e.getMessage());
    }catch(ArrayIndexOutOfBoundsException e1){
      System.out.print("Array Index Out Of Bounds Exception: " + e1.getMessage());
    }
  }

    public void downLoadData (String dirName, FundamentalTrader[] serie, FileOutputStream fileName){
    String lineBuffer = new String();
    String comma = new String(",");
    byte enter = Event.ENTER;
    try{
      lineBuffer = "TRADER,CASH,STOCKS,DECISION";
      fileName.write(lineBuffer.getBytes());
      fileName.write(enter);
      lineBuffer = new String();
       for(int i = 0; i < serie.length ; i++){
        lineBuffer += i+1;
        lineBuffer += comma;
        lineBuffer += serie[i].getCash();
        lineBuffer += comma;
        lineBuffer += serie[i].getNumberShares();
        lineBuffer += comma;
        lineBuffer += serie[i].getDecision();
        fileName.write(lineBuffer.getBytes());
        fileName.write(enter);
        lineBuffer = new String();
      }
    } catch(IOException e) {
      System.out.print("IO Exception: " + e.getMessage());
    }catch(ArrayIndexOutOfBoundsException e1){
      System.out.print("Array Index Out Of Bounds Exception: " + e1.getMessage());
    }
  }

}